/*
 * JBoss, Home of Professional Open Source
 * Copyright , Red Hat, Inc. and individual contributors
 * by the @authors tag. See the copyright.txt in the distribution for a
 * full listing of individual contributors.
 *
 * This is free software; you can redistribute it and/or modify it
 * under the terms of the GNU Lesser General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this software; if not, write to the Free
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.
 */
package org.richfaces.component;

import javax.annotation.Generated;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.List;

import javax.faces.context.FacesContext;
import javax.faces.component.UIComponent;
import javax.faces.component.behavior.ClientBehaviorHolder;
import javax.el.MethodExpression;
import javax.el.ValueExpression;
import javax.faces.component.StateHelper;
import org.richfaces.component.AbstractNotifyMessages;
import org.richfaces.CornerPosition;

/**
 *  @author Bernard Labno

 **/
@Generated({"RichFaces CDK", "4.1.0.20110805-M1"})
public class UINotifyMessages extends AbstractNotifyMessages
    implements ClientBehaviorHolder    {

    public static final String COMPONENT_TYPE="org.richfaces.NotifyMessages";

    public static final String COMPONENT_FAMILY="org.richfaces.Notify";

    @Override
    public String getFamily() {
        return COMPONENT_FAMILY;
    }

    public UINotifyMessages() {
        super();
        setRendererType("org.richfaces.NotifyMessagesRenderer");
    }

    private static final Collection<String> EVENT_NAMES = Collections.unmodifiableCollection(Arrays.asList(
        "beforedomupdate",
        "complete",
        "begin"
        ));
    
    public Collection<String> getEventNames() {
        return EVENT_NAMES;
    }


    public String getDefaultEventName() {
        return null;
    }


    protected enum Properties {
        ajaxRendered,
        animationSpeed,
        appearAnimation,
        data,
        delay,
        execute,
        hideAnimation,
        interval,
        keepTransient,
        limitRender,
        nonblocking,
        nonblockingOpacity,
        onbeforedomupdate,
        onbegin,
        oncomplete,
        position,
        render,
        showCloseButton,
        showHistory,
        showShadow,
        stack,
        status,
        stayTime,
        sticky,
        styleClass
        
    }

 
    public boolean isAjaxRendered() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.ajaxRendered, false);
        return value;
    }
    
    public void setAjaxRendered(boolean ajaxRendered) {
        getStateHelper().put(Properties.ajaxRendered, ajaxRendered);
    }

 
    public Integer getAnimationSpeed() {
        Integer value = (Integer) getStateHelper().eval(Properties.animationSpeed);
        return value;
    }
    
    public void setAnimationSpeed(Integer animationSpeed) {
        getStateHelper().put(Properties.animationSpeed, animationSpeed);
    }

 
    public String getAppearAnimation() {
        String value = (String) getStateHelper().eval(Properties.appearAnimation);
        return value;
    }
    
    public void setAppearAnimation(String appearAnimation) {
        getStateHelper().put(Properties.appearAnimation, appearAnimation);
    }

 
    public Object getData() {
        Object value = (Object) getStateHelper().eval(Properties.data);
        return value;
    }
    
    public void setData(Object data) {
        getStateHelper().put(Properties.data, data);
    }

 
    public Integer getDelay() {
        Integer value = (Integer) getStateHelper().eval(Properties.delay);
        return value;
    }
    
    public void setDelay(Integer delay) {
        getStateHelper().put(Properties.delay, delay);
    }

 
    public Object getExecute() {
        Object value = (Object) getStateHelper().eval(Properties.execute);
        return value;
    }
    
    public void setExecute(Object execute) {
        getStateHelper().put(Properties.execute, execute);
    }

 
    public String getHideAnimation() {
        String value = (String) getStateHelper().eval(Properties.hideAnimation);
        return value;
    }
    
    public void setHideAnimation(String hideAnimation) {
        getStateHelper().put(Properties.hideAnimation, hideAnimation);
    }

 
    public Integer getInterval() {
        Integer value = (Integer) getStateHelper().eval(Properties.interval);
        return value;
    }
    
    public void setInterval(Integer interval) {
        getStateHelper().put(Properties.interval, interval);
    }

 
    public boolean isKeepTransient() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.keepTransient, false);
        return value;
    }
    
    public void setKeepTransient(boolean keepTransient) {
        getStateHelper().put(Properties.keepTransient, keepTransient);
    }

 
    public boolean isLimitRender() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.limitRender, false);
        return value;
    }
    
    public void setLimitRender(boolean limitRender) {
        getStateHelper().put(Properties.limitRender, limitRender);
    }

 
    public boolean isNonblocking() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.nonblocking, false);
        return value;
    }
    
    public void setNonblocking(boolean nonblocking) {
        getStateHelper().put(Properties.nonblocking, nonblocking);
    }

 
    public Double getNonblockingOpacity() {
        Double value = (Double) getStateHelper().eval(Properties.nonblockingOpacity);
        return value;
    }
    
    public void setNonblockingOpacity(Double nonblockingOpacity) {
        getStateHelper().put(Properties.nonblockingOpacity, nonblockingOpacity);
    }

 
    public String getOnbeforedomupdate() {
        String value = (String) getStateHelper().eval(Properties.onbeforedomupdate);
        return value;
    }
    
    public void setOnbeforedomupdate(String onbeforedomupdate) {
        getStateHelper().put(Properties.onbeforedomupdate, onbeforedomupdate);
    }

 
    public String getOnbegin() {
        String value = (String) getStateHelper().eval(Properties.onbegin);
        return value;
    }
    
    public void setOnbegin(String onbegin) {
        getStateHelper().put(Properties.onbegin, onbegin);
    }

 
    public String getOncomplete() {
        String value = (String) getStateHelper().eval(Properties.oncomplete);
        return value;
    }
    
    public void setOncomplete(String oncomplete) {
        getStateHelper().put(Properties.oncomplete, oncomplete);
    }

 
    public CornerPosition getPosition() {
        CornerPosition value = (CornerPosition) getStateHelper().eval(Properties.position);
        return value;
    }
    
    public void setPosition(CornerPosition position) {
        getStateHelper().put(Properties.position, position);
    }

 
    public Object getRender() {
        Object value = (Object) getStateHelper().eval(Properties.render);
        return value;
    }
    
    public void setRender(Object render) {
        getStateHelper().put(Properties.render, render);
    }

 
    public boolean isShowCloseButton() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.showCloseButton, true);
        return value;
    }
    
    public void setShowCloseButton(boolean showCloseButton) {
        getStateHelper().put(Properties.showCloseButton, showCloseButton);
    }

 
    public boolean isShowHistory() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.showHistory, false);
        return value;
    }
    
    public void setShowHistory(boolean showHistory) {
        getStateHelper().put(Properties.showHistory, showHistory);
    }

 
    public boolean isShowShadow() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.showShadow, false);
        return value;
    }
    
    public void setShowShadow(boolean showShadow) {
        getStateHelper().put(Properties.showShadow, showShadow);
    }

 
    public String getStack() {
        String value = (String) getStateHelper().eval(Properties.stack);
        return value;
    }
    
    public void setStack(String stack) {
        getStateHelper().put(Properties.stack, stack);
    }

 
    public String getStatus() {
        String value = (String) getStateHelper().eval(Properties.status);
        return value;
    }
    
    public void setStatus(String status) {
        getStateHelper().put(Properties.status, status);
    }

 
    public Integer getStayTime() {
        Integer value = (Integer) getStateHelper().eval(Properties.stayTime);
        return value;
    }
    
    public void setStayTime(Integer stayTime) {
        getStateHelper().put(Properties.stayTime, stayTime);
    }

 
    public boolean isSticky() {
        Boolean value = (Boolean) getStateHelper().eval(Properties.sticky, false);
        return value;
    }
    
    public void setSticky(boolean sticky) {
        getStateHelper().put(Properties.sticky, sticky);
    }

 
    public String getStyleClass() {
        String value = (String) getStateHelper().eval(Properties.styleClass);
        return value;
    }
    
    public void setStyleClass(String styleClass) {
        getStateHelper().put(Properties.styleClass, styleClass);
    }

    

}